#!/usr/bin/perl

#Script by Bia Walter

#This script gets as input a fasta file containing the species and alignment positions of local structures. It creates as an output a table with the substructures and the species and alignment positions.

#$perl sub-table.pl substructures-ortho.fasta

use Data::Dumper;

my $reading_file = shift;
open ("reading_file", $reading_file) || die "It was not possible to open file $reading_file\n";

while (<reading_file>){
	chomp;
	if (/^>/){
		push @headers, "$_";          
	} 
}

close reading_file;

$i = 0;

foreach(@headers){
	@line = split /\s+/;
	@new = split (/-/, $line[4]); #Current alignment position	

	if ($i == 0){
		$local{$line[5]} = $line[4];
	} else {
		if ($local{$line[5]} eq ""){
			$local{$line[5]} = $line[4];
		} else {
			$int = $local{$line[5]};
			@old = split (/-/, $int); #Already set alignment position	
			if($new[0] <= $old[0]){ #Checking start of local structure
				$start = $new[0];
			} else {
				$start = $old[0];
			}
			if($new[1] >= $old[1]){ #Checking end of local structure
				$end = $new[1];
			} else {
				$end = $old[1]
			}
			$local{$line[5]} = $start."-".$end;
		}
	}
	$i = 1;
}

foreach my $sub (sort {$local{$a} <=> $local{$b}} keys %local){
	print "$sub\t$local{$sub}\n";
}



